var deviceID = '';
var mybool = true;
var coor = [[-1,-1],[-1,-1],[-1,-1]];
var imgArray = [['photo01.jpg', 'photo02.jpg', 'photo03.jpg', 'photo17.jpg', 'photo18.jpg', 'photo20.jpg'],
				['photo03.jpg', 'photo04.jpg', 'photo05.jpg', 'photo18.jpg', 'photo19.jpg', 'photo20.jpg'],
				['photo05.jpg', 'photo06.jpg', 'photo07.jpg', 'photo17.jpg', 'photo20.jpg', 'photo15.jpg'],
				['photo07.jpg', 'photo08.jpg', 'photo09.jpg', 'photo12.jpg', 'photo13.jpg', 'photo14.jpg'],
				['photo07.jpg', 'photo08.jpg', 'photo09.jpg', 'photo10.jpg', 'photo11.jpg', 'photo17.jpg'],
				['photo04.jpg', 'photo11.jpg', 'photo12.jpg', 'photo13.jpg'],
				['photo04.jpg', 'photo13.jpg', 'photo14.jpg', 'photo15.jpg'],
				['photo06.jpg', 'photo15.jpg', 'photo16.jpg', 'photo17.jpg']];
var logArray = [''];

var TuioCanvas = {
    init: function() {
        this.Main.init();
    }
};

TuioCanvas.Main = (function() {
    var client = null,
    screenW = null,
    screenH = null,
    time = null,
    canvas = null,
    context = null,
    objSize = 50,

    init = function() {
        screenW = $(window).innerWidth();
        screenH = $(window).innerHeight();
        time = new Date().getTime();
        canvas = $("#tuioCanvas").get(0);
        canvas.width = screenW;
        canvas.height = screenH;
        context = canvas.getContext("2d");

        initClient();
    },

    initClient = function() {
        client = new Tuio.Client({
            host: "http://localhost:5000"
        });
        client.on("connect", onConnect);
        client.connect();
    },

    onConnect = function() {
        draw();
    },

    draw = function() {
        requestAnimationFrame(draw);

        context.fillStyle = "#ffffff";
        context.fillRect(0, 0, canvas.width, canvas.height);

        var cursors = client.getTuioCursors(),
        objects = client.getTuioObjects();

        for (var i in cursors) {
            drawCursor(cursors[i]);
        }

        for (var i in objects) {
			drawObject(objects[i]);
        }
    },

    drawCursor = function(cursor) {
        context.fillStyle = "#009fe3";
        context.beginPath();
        context.arc(
            cursor.getScreenX(screenW),
            cursor.getScreenY(screenH),
            objSize * 0.5,
            0,
            Math.PI * 2
        );
        context.closePath();
        context.fill();
    },

	// Images
    drawObject = function(object) {
        context.save();
		//calibration();
		//var getCalXY = calibration(object.getX(), object.getY());
		//document.getElementById('message').innerHTML = 'x: ' + object.getX() + ', y: ' + object.getY() + ", :" + getCalXY[0] +", " + getCalXY[1];
		
        context.translate( /*0.2,-40.0*/
			//object.getScreenX(getCalXY[0]), object.getScreenX(getCalXY[1])
            object.getScreenX(screenW) + objSize * 0.5,
            object.getScreenY(screenH) + objSize * 0.5
        );
        context.rotate(object.getAngle());
		
		deviceID = '' + object.symbolId;

        context.fillStyle = "black";
        context.fillRect(-objSize * 0.5, -objSize * 0.5, objSize, objSize);
		context.fillStyle = "red";
		context.font = "18pt Arial";
		context.fillText(deviceID, -objSize * 0.1, -objSize * 0.1);
        context.restore();
		
		coor[object.symbolId][0] = object.getX();
		coor[object.symbolId][1] = object.getY();
		
		var findDistance = -1;
		
		//for (var i = 0; i < coor.length; i++) {
		//	if (coor[i][0] != -1)
		//	for (var j = i + 1; j < coor.length; j++) {
				
		//	}
			//for (var j = 0; j < 
			//if (coor[i][0] != -1) {
			//}
		//}
		
		if (coor[1][0] != -1 && coor[2][0] != -1) {
			findDistance = Math.sqrt(Math.pow(coor[1][1] - coor[1][0], 2) + Math.pow(coor[2][1] - coor[2][0], 2));
		}
		var imageURLs = "";
		
		if (findDistance < 1 && findDistance != -1) {
			for (var i = 0; i < imgArray[0].length; i++) {
				for (var j = 0; j < imgArray[1].length; j++) {
					if (imgArray[0][i] == imgArray[1][j]) {
						for (var k = 0; k < logArray.length; k++) {
							if (logArray[k] == imgArray[0][i]) {
								mybool = false;
							}
						}
						if (mybool) {
							$('#commonImages').append('<img src="images/1/' + imgArray[0][i] + '" height="100">');
							logArray[i] = imgArray[0][i];
						}
					}
				}
			}
		}
		
		var off = document.getElementById(deviceID).offsetWidth;
		
		document.getElementById(deviceID).style.left = object.getScreenX(screenW) - ((off * 0.5) - (objSize * 0.5))  + 'px' ;
		document.getElementById(deviceID).style.top = object.getScreenY(screenH) + objSize + 'px';
		//document.getElementById(deviceID).style.transform = 'rotate(' + object.getAngle() + 'deg)';
    };
	
	/*
	function showImage(src, width, height, posX, posY) {
	var myCanvas = document.getElementById("tuioCanvas");
	var ctx = myCanvas.getContext("2d");
	posX = posX * 900;
    posY = posY * 500;
	
	var img = new Image();
    img.src = src;
	img.draggable="true";
	img.ondragstart="drag(event)";
	
	ctx.drawImage(img, posX, posY, width, height);	
}*/

    return {
        init: init
    };
}());

function calibration(x, y) {
	var sx = [20.0, 20.0, 1419.0];
	var sy = [775.0, 40.0, 775.0];

	var cx = [0.13457, 0.03281, 0.61134];
	var cy = [0.65295, 0.94929, 0.58729];

	var sxdiff0 = sx[1] - sx[0];
	var sxdiff1 = sx[2] - sx[0];
	       
	var sydiff0 = sy[1] - sy[0];
	var sydiff1 = sy[2] - sy[0];

	var cxdiff0 = cx[1] - cx[0];
	var cxdiff1 = cx[2] - cx[0];

	var cydiff0 = cy[1] - cy[0];
	var cydiff1 = cy[2] - cy[0];
	
	var k =  (cydiff0/cxdiff0) - (cydiff1/cxdiff1);

	var b = ((sxdiff0/cxdiff0) - (sxdiff1/cxdiff1)) / k;
	var d = ((sydiff0/cydiff0) - (sydiff1/cydiff1)) / k;

	var a = (sxdiff0 - b*cxdiff0) / cxdiff0;
	var c = (sydiff0 - d*cydiff0) / cxdiff0;

	var tx = sx[0] - (a*cx[0] + b*cy[0]);
	var ty = sy[0] - (c*cx[0] + d*cy[0]);
	
	var result = [[0.0, 0.0],[0.0, 0.0],[0.0, 0.0]];
	//result[3][2]

	result[0][0] = a;
	result[0][1] = c;

	result[1][0] = b;
	result[1][1] = d;

	result[2][0] = tx;
	result[2][1] = ty;

	/** TO USE CALIBRATION TRANSFORMS **/

	// Transform
	var calX = x * result[0][0] + y * result[0][1];
	var calY = x * result[1][0] + y * result[1][1];

	// Transpose
	calX += result[2][0];
	calY += result[2][1];
	
	var calXY = [calX, calY];
	//document.getElementById('message').innerHTML = 'calX: ' + calX + ', calY: ' + calY;

	return calXY;
}

function getDeviceID() {
	return deviceID;
}